//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SvrMain.h"
#include "SvrThrd.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "MSocket"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MUDP1Request(TObject *Sender, AnsiString aRequest)
{
    if ( aRequest == "Request" )
        MUDP1->ServerSocket->SendString( "Ok!" );
    else
        MUDP1->ServerSocket->SendString( "Error!" );
}
//---------------------------------------------------------------------------

void __fastcall TForm1::chkUDPServerClick(TObject *Sender)
{
    MUDP1->Active = chkUDPServer->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::chkTCPServerClick(TObject *Sender)
{
    if ( chkServerSocket->Checked && ServerSocket1->Active )
      	chkServerSocket->Checked = false;
    FServerSocket->Active = chkTCPServer->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::chkServerSocketClick(TObject *Sender)
{
    if ( chkTCPServer->Checked && FServerSocket->Active )
    	chkTCPServer->Checked = false;
    ServerSocket1->Active = chkServerSocket->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
    FServerSocket = new TMTCPServer( );
    FServerSocket->LocalPort = 10002;
    FServerSocket->OnConnect = ServerConnect;
    if ( FileExists( "C:\\sock.log" ) )
        Memo1->Lines->LoadFromFile( "C:\\sock.log" );
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
    Memo1->Lines->SaveToFile( "C:\\sock.log" );
    delete FServerSocket;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ServerConnect( TObject * Sender, TMCustomTCP * aSocket )
{
    new TServerThread( aSocket );
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ServerSocket1GetThread(TObject *Sender,
      TServerClientWinSocket *ClientSocket,
      TServerClientThread *&SocketThread)
{
    SocketThread = new TSvrSocketThread( false, ClientSocket );
}
//---------------------------------------------------------------------------

