unit clnMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MSocket, StdCtrls, ScktComp;

type
  TForm2 = class(TForm)
    MUDP1: TMUDP;
    Edit1: TEdit;
    Button1: TButton;
    Edit2: TEdit;
    Edit3: TEdit;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit4: TEdit;
    Button3: TButton;
    ClientSocket1: TClientSocket;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

uses MBSocket;

{$R *.DFM}

procedure TForm2.Button1Click(Sender: TObject);
begin
    Edit2.Text := MUDP1.SendRequest( Edit1.Text );
end;

procedure TForm2.Button2Click(Sender: TObject);
Var
    aSocket : TMTCPClient;
    aData   : TMemoryStream;
begin
    aSocket := TMTCPClient.Create;
    aData := TMemoryStream.Create;
    Try
	    aSocket.RemoteHost := 'localhost';
    	aSocket.RemotePort := 10002;
	    aSocket.Open;
        aSocket.SendText( Edit3.Text + #13#10 );
        aSocket.RecvData( aData );
    	aData.SaveToFile( Edit4.Text );
    Finally
	    aData.Free;
    	aSocket.Free;
    End;
end;

procedure TForm2.Button3Click(Sender: TObject);
Var
    strm  : TMBWinSocketStream;
    aFile : TFileStream;
begin
	ClientSocket1.Open;
    strm := TMBWinSocketStream.Create( ClientSocket1.Socket, 1000 );
    Try
        strm.SendText( Edit3.Text + #13#10 );
        aFile := TFileStream.Create( Edit4.Text, fmCreate );
        Try
            strm.RecvStream( aFile );
        Finally
            aFile.Free;
        End;
    Finally
        strm.Free;
    End;
    ClientSocket1.Close;
end;

end.
