(*
    svrThrd : һڷ˶߳ TCP ͨŵĵԪ(DEMO)
    Copyright (c) Jul.29-01 13:58, Apr.05-02 by Mental Studio -- http://msrc.126.com
    Author  : <raptorz@163.com>
    Version : 1.1
    Comment : Ԫ߳ TTCPServerThread  TSvrSocketThread

    TTCPServerThread  TMTCPServer Ϊ˴̣߳
    ÿ TTCPServerThread һͻӣ
     TTCPServerThread  Execute дͻ˵ͨš
    
    TSvrSocketThread  TServerSocket ҲǷ˴̣߳
     TServerClientSocket ʹ TMBWinSocketStream 
*)
unit svrThrd;

interface

uses
  Classes, MSocket, SysUtils, ScktComp, MBSocket;

type
    TTCPServerThread = Class( TThread )
    Private
        FSocket : TMCustomTCP;
        FErrStr : String;

        Procedure WriteLog;
    Protected
        Procedure Execute; Override;
    Public
        Constructor Create( aSocket : TMCustomTCP );
    End;

    TSvrSocketThread = Class( TServerClientThread )
    Private
        FErrStr : String;

        Procedure WriteLog;
    Protected
        Procedure ClientExecute; Override;
    End;

implementation

Uses
    svrMain;

{ TServerThread }

Constructor TTCPServerThread.Create( aSocket : TMCustomTCP );
Begin
    Inherited Create( false );
    FreeOnTerminate := true;
    FSocket := aSocket;
End;

procedure TTCPServerThread.Execute;

    Procedure AddLog( aStr : String );
    Begin
        FErrStr := aStr;
        Synchronize( WriteLog );
    End;

Var
    aData : TMemoryStream;
    s     : String;
begin
	aData := TMemoryStream.Create;
    Try
    	While ( ( Not Terminated ) AND ( Not FSocket.WaitForRecv ) ) Do;
        If ( Not Terminated ) Then
        Begin
            s := FSocket.RecvText;
            AddLog( s );
            aData.LoadFromFile( s );
            AddLog( IntToStr( aData.Size ) );
    	    FSocket.SendData( aData );
            AddLog( 'Sent ok' );
        End;
    	While ( ( Not Terminated ) AND ( Not FSocket.WaitForRecv ) ) Do;
    Except
        On e : Exception Do
            AddLog( 'Error:' + e.Message );
    End;
	aData.Free;
    FSocket.Free;
end;

procedure TTCPServerThread.WriteLog;
begin
    Form1.Memo1.Lines.Add( FErrStr );
end;

{ TSvrSocketThread }

procedure TSvrSocketThread.ClientExecute;

    Procedure AddLog( aStr : String );
    Begin
        FErrStr := aStr;
        Synchronize( WriteLog );
    End;

Var
    fs    : TFileStream;
    strm  : TMBWinSocketStream;
    s     : String;
begin
    strm := TMBWinSocketStream.Create( ClientSocket, 100000 );
    Try
        s := strm.RecvText;
        AddLog( s );
        fs := TFileStream.Create( s, fmOpenRead );
        Try
            AddLog( IntToStr( fs.Size ) );
            strm.SendStream( fs );
            AddLog( 'Sent ok' );
        Finally
            fs.Free;
            strm.Free;
            ClientSocket.Close;
        End;
    Except
        On e : Exception Do
            AddLog( 'Error:' + e.Message );
    End;
end;

procedure TSvrSocketThread.WriteLog;
begin
    Form1.Memo1.Lines.Add( FErrStr );
end;

end.

